// formatJson() :: formats and indents JSON string
function formatJson(val) {
	var retval = '';
	var str = val;
    var pos = 0;
    var strLen = str.length;
	var indentStr = '  ';
    var newLine = "\n";
	var char = '';
	
	for (var i=0; i<strLen; i++) {
		char = str.substring(i,i+1);
		
		if (char == '}' || char == ']') {
			retval = retval + newLine;
			pos = pos - 1;
			
			for (var j=0; j<pos; j++) {
				retval = retval + indentStr;
			}
		}
		
		retval = retval + char;	
		
		if (char == '{' || char == '[' || char == ',') {
			retval = retval + newLine;
			
			if (char == '{' || char == '[') {
				pos = pos + 1;
			}
			
			for (var k=0; k<pos; k++) {
				retval = retval + indentStr;
			}
		}
	}
	
	return retval;
}



$(function(){
  
  $('h1 a').click(function(e){
    $('input[type=checkbox]').attr('checked', false)
    $('.switch a:first-child').click()
    $('a.reload').addClass('hover')
    setTimeout(function(){
      $('a.reload').addClass('loading')
    }, 100)
    e.preventDefault()
  })
  
  function createUrl(){
    var multiple = $('.switch').hasClass('array');
    var jsonp = $('input[type=checkbox]').attr('checked') == 'checked';
    var path = document.location.origin + "/json";
    var params = []
    if(multiple){
      params.push("n=100")
    }
    if(jsonp){
      params.push("callback=?")
    }
    url = path
    if(params.length > 0){
      url += "?" + params.join('&')
    } 
    $('code').text(url)
  }
  
  $('.switch span').click(function(){
    // alert('a')
  })
  
  $('input, .switch a, .switch span').mousedown(function(){
    setTimeout(function(){
      createUrl();
      setTimeout(function(){
        reloadJson();
      })
    }, 10)
  })
  
  $('*:not(pre), *:not(code)').on('click', function(e){
    if($(this)[0].tagName == 'PRE' || $(this)[0].tagName == 'CODE'){
      e.stopPropagation()
    }else{
      $('pre, code').removeClass('focus')
    }
  })
    
  $('pre, code').on('click', function(e){
    if($(this).hasClass('focus')){
      // return false
    }else{
      e.stopPropagation();
      $(this).addClass('focus');
      var refNode = $( this )[0];
      if ( $.browser.msie ) {
          var range = document.body.createTextRange();
          range.moveToElementText( refNode );
          range.select();
      } else if ( $.browser.mozilla || $.browser.opera ) {
          var selection = window.getSelection();
          var range = document.createRange();
          range.selectNodeContents( refNode );
          selection.removeAllRanges();
          selection.addRange( range );
      } else if ( $.browser.safari ) {
          var selection = window.getSelection();
          selection.setBaseAndExtent( refNode, 0, refNode, 1 );
      }
      $('small').fadeIn('100');
    }
  });
  $('pre, code').on('focusout', function(){
    $('small').fadeOut();
  });
  $('.switch a').click(function(e){
    e.preventDefault()
  })
  $('.switch a:first-of-type').on('click', function(e){
    $(this).parent().removeClass('array');
    $(this).parent().addClass('single');
  });
  $('.switch a:last-of-type').on('click', function(){
    $(this).parent().removeClass('single');
    $(this).parent().addClass('array');
  });
  $('.switch.single span').live('mousedown', function(){
    $(this).parent().removeClass('single');
    $(this).parent().addClass('array');
  });
  $('.switch.array span').live('mousedown', function(){
    $(this).parent().removeClass('array');
    $(this).parent().addClass('single');
  });
  $('a.reload').on('click', function(){
    $(this).addClass('loading');
    return false;
  });
  
  $('pre, code').keydown(function(e){
    if(!e.metaKey && !e.ctrlKey && !e.altKey){
      e.preventDefault();
    }
  })
  
  var reloadJson = function(){
    $('pre').text('')
    var url = $('.json code').text()
    url = url.replace('callback', 'fake_callback_for_ajax_demo')
    $.getJSON(url, function(data){
      var text = formatJson(JSON.stringify(data))
      $('pre').text(text)
      // setTimeout(function(){
        $('a.reload').removeClass('loading').removeClass('hover')
      // }, 1000)
    })
  }
  
  $('a.reload').click(function(e){
    $(this).addClass('hover')
    reloadJson()
    e.preventDefault()
  })
  
  $(window).resize(function(){
    var height = $(window).height() - 450
    if(height < 60){
      height = 60
    }
    $('.json').css('height', height)
  })
  $(window).resize()
  
})

jQuery9028374892374 = function(data){
  $('pre').text("jQuery9028374892374("+formatJson(JSON.stringify(data))+")")
}